package cn.com.infosec.asn1.cmp;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;
import cn.com.infosec.asn1.crmf.CertTemplate;
import cn.com.infosec.asn1.x509.X509Extensions;

public class RevDetails extends ASN1Encodable {
   private CertTemplate certDetails;
   private X509Extensions crlEntryDetails;

   private RevDetails(ASN1Sequence seq) {
      this.certDetails = CertTemplate.getInstance(seq.getObjectAt(0));
      if (seq.size() > 1) {
         this.crlEntryDetails = X509Extensions.getInstance(seq.getObjectAt(1));
      }

   }

   public static RevDetails getInstance(Object o) {
      if (o instanceof RevDetails) {
         return (RevDetails)o;
      } else if (o instanceof ASN1Sequence) {
         return new RevDetails((ASN1Sequence)o);
      } else {
         throw new IllegalArgumentException("Invalid object: " + o.getClass().getName());
      }
   }

   public CertTemplate getCertDetails() {
      return this.certDetails;
   }

   public X509Extensions getCrlEntryDetails() {
      return this.crlEntryDetails;
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10001 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var10001.add(this.certDetails);
      X509Extensions var2;
      if ((var2 = this.crlEntryDetails) != null) {
         var1.add(var2);
      }

      return new DERSequence(var1);
   }
}
